// color LED driver
// output pin = RB6, RB7, RB8

#include <p30f2012.h>         // include dsPIC30F2012 header file
#include <stdlib.h>           // for rand() function

#define PERIOD 1000
#define LOOP    400

int main(void) {
  unsigned i, t;
  int      duty6, duty7, duty8;
  float    new6, new7, new8;
  float    last6, last7, last8;
  float    sum;

  //ADPCFG=0xffff;            // disable all A/D input pin

  TRISBbits.TRISB6=0;         // RB6 is output  
  TRISBbits.TRISB7=0;         // RB7 is output
  TRISBbits.TRISB8=0;         // RB8 is output

  t=0;
  duty6=0; last6=0;
  duty7=0; last7=LOOP/2;
  duty8=0; last8=LOOP/3;

  while(1) {         
    // PWM modulation 
    PORTB=0;
    for (i=0; i<PERIOD; i=i+1) {
      if (duty6<i) PORTBbits.RB6=1;      
      if (duty7<i) PORTBbits.RB7=1;
      if (duty8<i) PORTBbits.RB8=1;
      asm("repeat #100");     // repeat next instruction
      asm("nop");             // wait...
    }                      
    // change PWM duty ratio 
    t=(t+1)%LOOP;
    if (t==0) {
      last6=new6;
      last7=new7;
      last8=new8;
      new6=rand(); 
      new7=rand(); 
      new8=rand();
      sum=new6+new7+new8;
      new6=0.99*new6/sum*PERIOD;
      new7=0.99*new7/sum*PERIOD;
      new8=0.99*new8/sum*PERIOD;
    }
    duty6=last6+(new6-last6)*t/LOOP;
    duty7=last7+(new7-last7)*t/LOOP;
    duty8=last8+(new8-last8)*t/LOOP;
  }

}
