// color LED driver (Anode Common)
// RS-232C input = U1ARX/UARX
// output pin    = RB6(Red), RB7(Green), RB8(Blue)

#include <p30f2012.h>     // include dsPIC30F2012 header file

int main(void) {
  unsigned table[9]={1, 2, 4, 8, 16, 32, 64, 128, 256};
  unsigned data, color, width;
  unsigned i;

  //ADPCFG=0xffff;              // disable all A/D input pin

  U1MODE=0x8400;                // use U1ARX(UARX) 
  U1BRG =95;                    // 19200bps (29.48MHz/16/19200-1=95)

  TRISBbits.TRISB6=0;           // RB6 is output (Red) 
  TRISBbits.TRISB7=0;           // RB7 is output (Green)
  TRISBbits.TRISB8=0;           // RB8 is output (Blue)
  TRISCbits.TRISC13=0;          // RC13 is output (on board LED)

  color=0xfe3f;                                // all LED on
  width=32;                                    // medium brightness

  while(1) {                                   // forever loop
    if (U1STAbits.URXDA==1) {                  // if RX data exists
      data=U1RXREG;                            // read RX data
      PORTCbits.RC13=~PORTCbits.RC13;          // toggle on board LED
      if ((data=='r')||(data=='R')) {          // 'r' or 'R'
        color=0xffbf;                          // Red LED on
      } else if ((data=='g')||(data=='G')) {   // 'g' or 'G'
        color=0xff7f;                          // Green LED on
      } else if ((data=='b')||(data=='B')) {   // 'b' or 'B'
        color=0xfeff;                          // Blue LED on
      } else if ((data=='c')||(data=='C')) {   // 'c' or 'C' (Cyan)
        color=0xfe7f;                          // Green/Blue LED on
      } else if ((data=='m')||(data=='M')) {   // 'm' or 'M' (Magenta)
        color=0xfebf;                          // Red/Blue LED on
      } else if ((data=='y')||(data=='Y')) {   // 'y' or 'Y' (Yellow)
        color=0xff3f;                          // Red/Green LED on
      } else if ((data=='w')||(data=='W')) {   // 'w' or 'W'
        color=0xfe3f;                          // all LED on
      } else if (('1'<=data)&&(data<='9')) {   // '1'..'9'
        width=table[data-'1'];                 // set pulse width
      }
    }
    PORTB=color;                               // LED on
    for (i=0; i<256*10; i=i+1) {               // software PWM modulation
      if ((width*10)<=i) PORTB=0xffff;         // LED off
      asm("repeat #50");                       // repeat next instruction
      asm("nop");                              // wait...
    }
  }

}
