// PWM fan controller
//   control data input : U1ARX/UARX/RC14(RS-232C input)
//   PWM output pin     : RB6

#include <p30f2012.h>           // include dsPIC30F2012 header file

int main(void) {
  unsigned cmd;                          // received character 
  unsigned width;                        // pulse width 
  unsigned i;

  TRISBbits.TRISB6 =0;                   // RB6 is output
  TRISCbits.TRISC13=0;                   // RC13 is output(LED)

  U1MODE=0x8400;                         // use U1ARX/UARX 
  U1BRG =95;                             // 19200bps (29.48MHz/16/19200-1=95)

  width=8;
  while(1) {                             // forever loop
    if (U1STAbits.URXDA==1) {            // if incoming data exists
      cmd=U1RXREG;                       // receive a charcater
      if (('1'<=cmd)&&(cmd<='9')) {      // if cmd='1'..'9'
        width=1+cmd-'1';                 // width=1,2,3,..,9
        PORTCbits.RC13=~PORTCbits.RC13;  // toggle Green/Red LED
      }
    }
    PORTBbits.RB6=0;                     // RB6=0
    for (i=0; i<9; i=i+1) {              // software PWM modulation
      if (width<=i) PORTBbits.RB6=1;     // RB6=1
      asm("repeat #5000");               // repeat next instruction
      asm("nop");                        // wait...
    }
  }

}
